/* Verwerken van "AEX", bepalend voor handelsdagen, en daarna de rest */

CALL RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
CALL SysLoadFuncs

bron='AEX'

SAY
IF Stream(bron,'C','QUERY EXISTS')='' THEN DO
   SAY 'Fout: bestand' bron 'niet gevonden'
   SAY
   EXIT
END

teller=0
DO WHILE Lines(bron)>0
   regel=Strip(LineIn(bron))
   IF DataType(Left(regel,1))='NUM' THEN DO 
      teller=teller+1
      PARSE VAR regel dag ';' open ';' hoog ';' laag ';' slot ';' omzet
      DO WHILE Pos(',',open,1)>0
         PARSE VAR open deel1 ',' deel2
         open=deel1||deel2
      END
      DO WHILE Pos(',',hoog,1)>0
         PARSE VAR hoog deel1 ',' deel2
         hoog=deel1||deel2
      END
      DO WHILE Pos(',',laag,1)>0
         PARSE VAR laag deel1 ',' deel2
         laag=deel1||deel2
      END
      DO WHILE Pos(',',slot,1)>0
         PARSE VAR slot deel1 ',' deel2
         slot=deel1||deel2
      END
      IF omzet<>'-' THEN DO
         IF omzet<>'0' THEN DO
            SAY 'Fout: veld omzet is niet gelijk aan "-" of "0" in bestand' bron
            SAY 'Regel:' regel
            SAY
            CALL LineOut bron
            EXIT
         END
      END
      datum=Date('S',dag,'E')
      regel.teller=datum||','||open||','||hoog||','||laag||','||slot||','||'0'
   END
END
CALL LineOut bron
regel.0=teller

IF regel.0=0 THEN DO
   SAY 'Fout:' regel.0 'regels ingelezen uit bestand' bron
   SAY
   EXIT
END

SAY regel.0 'regels ingelezen uit bestand' bron||'.'

jaren.0=0
DO i=1 TO regel.0
   jaar=Left(regel.i,4)
   gevonden=0
   DO j=1 TO jaren.0      
      IF jaren.j=jaar THEN gevonden=j   
   END j
   IF gevonden=0 THEN DO
      hulp=(jaren.0)+1
      jaren.0=hulp
      jaren.hulp=Strip(jaar)
   END
END i

IF jaren.0=0 THEN DO
   SAY 'Fout: aantal jaren met gegevens is' jaren.0
   EXIT
END

SAY
DO i=1 TO jaren.0
   SAY 'Gegevens uit' jaren.i 'gevonden.'
   doel=jaren.i||'.PRN'
   IF Stream(doel,'C','QUERY EXISTS')='' THEN DO
      CALL LineOut doel,'<TICKER>,<PER>,<DTYYYYMMDD>,<OPEN>,<HIGH>,<LOW>,<CLOSE>,<VOL>,<OI>'
      CALL LineOut doel
      SAY 'Bestand' doel 'aangemaakt.'
   END
END i
SAY

ankers=0
DO i=1 TO jaren.0
   bron=jaren.i||'.PRN'
   SAY 'Inlezen van bestand' bron||'...'
   CALL LineIn bron
   DO WHILE Lines(bron)>0
      regel=Strip(LineIn(bron))
      IF Left(regel,4)='AEX,' THEN DO
         ankers=ankers+1
         PARSE VAR regel . ',' . ',' anker.ankers
      END
   END
   CALL LineOut bron
END i
anker.0=ankers
SAY 'Aantal bestaande regels:' anker.0
SAY

overgeslagen=0
toegevoegd=0
DO i=1 TO regel.0
   gevonden=0
   DO j=1 TO anker.0
      IF regel.i==anker.j THEN DO
         gevonden=gevonden+1
      END
      PARSE VAR anker.i datum1 ',' rest1
      PARSE VAR regel.i datum2 ',' rest2
      IF datum1==datum2 THEN DO
         IF rest1<>rest2 THEN DO
            SAY 'Fout: verschil in waarden op' datum1
            SAY 'Oud  : AEX,D,'||datum1||','||rest1
            SAY 'Nieuw: AEX,D,'||datum2||','||rest2
            EXIT
         END
      END
   END j
   IF gevonden=0 THEN DO
      doel=Left(regel.i,4)||'.PRN'
      CALL lineOut doel,'AEX,D,'||regel.i
      CALL LineOut doel
      toegevoegd=toegevoegd+1
   END
   IF gevonden=1 THEN overgeslagen=overgeslagen+1
   IF gevonden>1 THEN DO
      SAY 'Fout: AEX,D,'||regel.i 'komt meerdere keren voor in' Left(regel.i,4)||'.PRN'
      EXIT
   END
END i

SAY 'Aantal regels overgeslagen:' overgeslagen
SAY 'Aantal regels toegevoegd  :' toegevoegd
SAY

IF overgeslagen+toegevoegd=regel.0 THEN CALL SysFileDelete 'AEX'
IF overgeslagen+toegevoegd<>regel.0 THEN DO
   SAY 'Fout: aantallen kloppen niet'
   SAY
   EXIT
END

bron='AANDELEN.LST'
IF Stream(bron,'C','QUERY EXISTS')='' THEN DO
   SAY 'Fout: bestand' bron 'niet gevonden'
   EXIT
END

teller=0
DO WHILE Lines(bron)>0
   PARSE VALUE LineIn(bron) WITH 1 symbool 11 .
   symbool=Strip(symbool)
   IF symbool<>'AEX' THEN DO
      teller=teller+1
      symbool.teller=symbool
   END
END
symbool.0=teller

IF symbool.0=0 THEN DO
   SAY 'Fout: geen te verwerken symbolen gevonden in' bron
   EXIT
END

SAY symbool.0 'te werken symbolen gevonden.'

fouten=0
DO i=1 TO symbool.0
   IF Stream(symbool.i,'C','QUERY EXISTS')='' THEN DO
      fouten=fouten+1 
      SAY 'Fout: bestand' symbool.i 'niet gevonden'
   END
END i
IF fouten>0 THEN EXIT

DO i=1 TO symbool.0
   bron=symbool.i
   teller=0
   DO WHILE Lines(bron)>0
      regel=Strip(LineIn(bron))
      IF DataType(Left(regel,1))='NUM' THEN DO 
         teller=teller+1
         PARSE VAR regel dag ';' open ';' hoog ';' laag ';' slot ';' omzet
         DO WHILE Pos(',',open,1)>0
            PARSE VAR open deel1 ',' deel2
            open=deel1||deel2
         END
         DO WHILE Pos(',',hoog,1)>0
            PARSE VAR hoog deel1 ',' deel2
            hoog=deel1||deel2
         END
         DO WHILE Pos(',',laag,1)>0
            PARSE VAR laag deel1 ',' deel2
            laag=deel1||deel2
         END
         DO WHILE Pos(',',slot,1)>0
            PARSE VAR slot deel1 ',' deel2
            slot=deel1||deel2
         END
         IF omzet='-' THEN omzet=0
         DO WHILE Pos(',',omzet,1)>0
            PARSE VAR omzet deel1 ',' deel2
            omzet=deel1||deel2
         END
         datum=Date('S',dag,'E')
         regel.teller=datum||','||open||','||hoog||','||laag||','||slot||','||omzet
      END
   END
   CALL LineOut bron
   regel.0=teller
   IF regel.0=0 THEN SAY 'Waarschuwing: geen regels in' symbool.i
   IF regel.0>0 THEN DO   
      DO j=1 TO regel.0  
         doel=Left(regel.j,4)||'.PRN'
         CALL LineOut doel,symbool.i||',D,'||regel.j
         CALL LineOut doel
      END j
   END
   CALL SysFileDelete symbool.i
END i

EXIT

